<script>
var f = window.GearsFactory ? new GearsFactory() : new ActiveXObject("Gears.Factory");
var d = f.create("beta.desktop");
var icons = {
  "16x16": "16.png",
  "32x32": "32.png",
  "48x48": "48.png",
  "128x128": "128.png"
};
valid();

function valid() {
  d.createShortcut("My Application", "This application lets you do things!",
                   "http://mail.google.com/", icons);
}

function longDescription() {
  var longSentence = [];
  for (var i = 0; i < 100; i++) {
    longSentence.push("foo");
  }
  d.createShortcut("My Application", longSentence.join(" "),
                   "http://mail.google.com/", icons);
}

function reportError(f) {
  try {
    f();
  } catch (e) {
    window.setTimeout("throw new Error('" + e.message + "')", 0);
  }
}

function badArgs() {
  var bigString = [];
  for (var i = 0; i < 51; i++) {
    bigString.push("x");
  }
  
  reportError(function() { d.createShortcut() });
  reportError(function() { d.createShortcut("", "description", "url", icons) });
  reportError(function() { d.createShortcut(bigString.join(""), "description", "url", icons) });
  reportError(function() { d.createShortcut("foo\\bar", "description", "url", icons) });
  reportError(function() { d.createShortcut("name", "description", "url", {}) });
  reportError(function() { d.createShortcut("name", "description", "url", {"16x16": "32.png"}) });
  reportError(function() { d.createShortcut("name", "description", "url", {"16x16": "test.html"}) });
  reportError(function() { d.createShortcut("name", "description", "url", {"16x16": "does_not_exist"}) });
}
</script>

<button onclick="valid()">valid</button>
<button onclick="longDescription()">long description</button>
<button onclick="badArgs()">bad args</button>
